import grails.converters.JSON
import org.codehaus.groovy.grails.web.converters.configuration.DefaultConverterConfiguration
import org.codehaus.groovy.grails.web.converters.configuration.ConvertersConfigurationHolder
import com.emrul.grails.smartclient.converters.json.SmartclientDomainClassMarshaller
import com.emrul.grails.smartclient.JSInterfaceInjector
import grails.util.Environment
import org.codehaus.groovy.grails.commons.GrailsApplication
import org.codehaus.groovy.grails.commons.DomainClassArtefactHandler
import org.codehaus.groovy.grails.commons.GrailsDomainClass
import com.emrul.grails.smartclient.GrailsSmartClientSharedUtil
import org.springframework.core.io.FileSystemResource
import org.codehaus.groovy.grails.commons.spring.GrailsApplicationContext
import com.emrul.grails.smartclient.GrailsSmartClientDataSourceUtil
import com.emrul.grails.smartclient.GrailsSmartClientUtil
import org.codehaus.groovy.grails.web.context.ServletContextHolder
import org.codehaus.groovy.grails.commons.GrailsClassUtils
import org.codehaus.groovy.grails.support.proxy.DefaultProxyHandler
import org.codehaus.groovy.grails.support.proxy.ProxyHandler

class SmartgwtServerGrailsPlugin {
    // the plugin version
    def version = "0.4"
    // the version or versions of Grails the plugin is designed for
    def grailsVersion = "1.2.1 > *"
    // the other plugins this plugin depends on
    def dependsOn = [gwt:"0.5.1 > *"]
					//,springSecurityCore:"1.0.1 > *"]
	
	List loadAfter = ['spring-security-core', 'domainClass', 'hibernate']
    
	// resources that are excluded from plugin packaging
    def pluginExcludes = [
            "grails-app/views/error.gsp"
    ]
	
    // TODO Fill in these fields
    def author = "Emrul Islam"
    def authorEmail = "emrul@emrul.com"
    def title = "SmartGWT Server Integration for Grails"
    def description = '''\\
Brief description of the plugin.
'''
	
    // URL to the plugin's documentation
    def documentation = "http://grails.org/plugin/smartgwt-server"


	def watchedResources = 	["file:./smartclient/**/*"
							,"file:./grails-app/domain/**/*.groovy"
	                        ]


    def doWithWebDescriptor = { xml ->
		def lastFilter = xml.'filter'.iterator().toList().last()
		lastFilter + {
			'filter' {
				'filter-name' ("GOSIVFilter")
				'filter-class' ("org.codehaus.groovy.grails.orm.hibernate.support.GrailsOpenSessionInViewFilter")
			}			
		}

		def lastFilterMapping = xml.'filter-mapping'.iterator().toList().last()
		lastFilterMapping + {
			'filter-mapping' {
				'filter-name' ("GOSIVFilter")
				'url-pattern' ("/sc/IDACall/*")
			}
		}

        def lastServlet = xml.'servlet'.iterator().toList().last()
        lastServlet + {
            'servlet' {
                'servlet-name'('IDACall')
                'servlet-class'('com.isomorphic.servlet.IDACall')
            }
			'servlet' {
                'servlet-name'('DataSourceLoader')
                'servlet-class'('com.isomorphic.servlet.DataSourceLoader')
            }
			'servlet' {
                'servlet-name'('FileDownload')
                'servlet-class'('com.isomorphic.servlet.FileDownload')
            }
			'servlet' {
                'servlet-name'('Init')
                'servlet-class'('com.isomorphic.base.Init')
				'load-on-startup'('1')
            }
			'servlet' {
                'servlet-name'('HttpProxy')
                'servlet-class'('com.isomorphic.servlet.HttpProxyServlet')
            }
			'servlet' {
                'servlet-name'('PreCache')
                'servlet-class'('com.isomorphic.servlet.PreCache')
				'load-on-startup'('2')
            }
        }

        def lastServletMapping = xml.'servlet-mapping'.iterator().toList().last()
        lastServletMapping + {
            'servlet-mapping' {
                'servlet-name'('IDACall')
                'url-pattern'('/sc/IDACall/*')
            }
            'servlet-mapping' {
                'servlet-name'('DataSourceLoader')
                'url-pattern'('/sc/DataSourceLoader')
            }
            'servlet-mapping' {
                'servlet-name'('HttpProxy')
                'url-pattern'('/sc/HttpProxy/*')
            }
			'servlet-mapping' {
			    'servlet-name'('FileDownload')
			    'url-pattern'('/sc/skins/*')
			}
			'servlet-mapping' {
			    'servlet-name'('FileDownload')
			    'url-pattern'('/sc/system/modules/*')
			}
			'servlet-mapping' {
			    'servlet-name'('FileDownload')
			    'url-pattern'('/sc/system/development/*')
			}
			'servlet-mapping' {
			    'servlet-name'('FileDownload')
			    'url-pattern'('/sc/system/reference/skin/*')
			}
			'servlet-mapping' {
			    'servlet-name'('gsp')
			    'url-pattern'('*.xml')
			}
        }
        
		xml.'jsp-config' + {
			'taglib' {
				'taglib-uri'('isomorphic')
				'taglib-location'('/WEB-INF/iscTaglib.xml')
			}
		}
    }

    def doWithSpring = {
		// jsInterfaceInjectorBean(JSInterfaceInjector)
        smartGwtDomainClassMarshaller(com.emrul.grails.smartclient.converters.json.SmartclientDomainClassMarshaller, false) { bean ->
            bean.scope = 'singleton'
            bean.lazyInit = true
            bean.autowire = 'byName'
        }
        smartGwtSecurityManager(com.emrul.grails.smartclient.security.DefaultSecurityManager) { bean ->
            bean.scope = 'singleton'
        }
        grailsDatasourceBean(com.emrul.grails.smartclient.GrailsDataSourceFactory) { bean ->
            bean.scope = 'singleton'
            bean.factoryMethod = "createInstance"
            bean.lazyInit = true
            bean.autowire = 'byName'
        }
    }

    def doWithDynamicMethods = { ctx ->
		application.domainClasses.each { domainClass ->
			// domainClass.metaClass.getClassNode().addInterface(ClassHelper.make(JSTranslater.class))
			// domainClass.metaClass.mixin(DomainClassSupport.class)
			// domainClass.getMetaClass()
			/*
			domainClass.metaClass.toJSON = { Writer paramWriter, JSTranslater paramJSTranslater ->
				JSON.use("smartclient") {
					def converter = new JSON(this)
					converter.render(paramWriter)
				}
			}*/

			/*
			domainClass.class.metaClass.getProperty = { String name ->
				// do stuff before access
				def result
				def metaProperty = delegate.class.metaClass.getMetaProperty(name)
				if (metaProperty) {
				   result = metaProperty.getProperty(delegate)
				}
				else {
				   throw new MissingPropertyException(name, delegate.class)
				}
				// do stuff after access
				result
			}

			domainClass.class.metaClass.setProperty = { String name, value ->
				// do stuff before update
				def metaProperty = delegate.class.metaClass.getMetaProperty(name)
				if (metaProperty) {
				   metaProperty.setProperty(delegate, value)
				}
				else {
				   throw new MissingPropertyException(name, delegate.class)
				}
				// do stuff after update
			}
			*/
		}
    }

    def doWithApplicationContext = { applicationContext ->

        /*
        ProxyHandler proxyHandler;
        if (applicationContext != null) {
            proxyHandler = applicationContext.getBean(ProxyHandler.class);
        }
        else {
            proxyHandler = new DefaultProxyHandler();
        }
*/
		DefaultConverterConfiguration<JSON> smartclientDeepConfig = new DefaultConverterConfiguration<JSON>(ConvertersConfigurationHolder.getConverterConfiguration(JSON.class));
        //smartclientDeepConfig.registerObjectMarshaller(new org.codehaus.groovy.grails.web.converters.marshaller.json.DeepDomainClassMarshaller(true, proxyHandler), 100)
		smartclientDeepConfig.registerObjectMarshaller( applicationContext.getBean("smartGwtDomainClassMarshaller"), 100);
		// smartclientDeepConfig.registerObjectMarshaller(new SmartclientDomainClassMarshaller(false), 100);
		smartclientDeepConfig.registerObjectMarshaller(new org.codehaus.groovy.grails.web.converters.marshaller.json.JavascriptDateMarshaller(), 100);
		ConvertersConfigurationHolder.setNamedConverterConfiguration(JSON.class, "smartclient", smartclientDeepConfig);
    }

    def onChange = { event ->
		if( Environment.current==Environment.DEVELOPMENT ) {
			GrailsApplication grailsApp = event.application
			GrailsApplicationContext appCtx = event.ctx

			// Note: Getting basedir like below requires Grails dev environment in default config (i.e. Tomcat)
			String basedir =  System.getProperty("base.dir")

			if ( event.source instanceof FileSystemResource ) {
				File file = event.source.getFile()
				String fileName = file.name
				String baseName = fileName[0 .. fileName.indexOf('.')-1]
				if ( fileName.endsWith(".ds.xml") || fileName.endsWith(".ds.groovy") ) {
					String destDirPath = "${basedir}/web-app/shared/ds"
					if ( file.parentFile.isDirectory() && file.parentFile.name == "test_data" ) {
						File destTestDataDir = new File("${destDirPath}/test_data")
						if ( !destTestDataDir.exists() ) {
							destTestDataDir.mkdir()
						}
						println("Reloading SmartClient Test Data: '${baseName}'")
						GrailsSmartClientDataSourceUtil.outputDataSource( file, destTestDataDir.path)
					}
					else {
						println("Reloading SmartClient Data Source: '${baseName}'")
						GrailsSmartClientDataSourceUtil.outputDataSource( file, destDirPath)
					}
				}
				else if ( fileName.endsWith(".ui.xml") || fileName.endsWith(".ui.groovy") ) {
					println("Reloading SmartClient User Interface: '${baseName}'")
					GrailsSmartClientUtil.outputUserInterface( file,"${basedir}/web-app/shared/ui")
				}
			}
			else if ( GrailsClassUtils.getStaticPropertyValue(event.source, 'expose')?.contains('smartclient') ) {
				// TODO: Service Integration
			}
			else if ( grailsApp.isArtefactOfType( DomainClassArtefactHandler.TYPE, event.source.name ) ) {
				GrailsDomainClass domainClass = (GrailsDomainClass) grailsApp.getArtefact(DomainClassArtefactHandler.TYPE, event.source.name)
				if ( GrailsSmartClientSharedUtil.isSmartClientEnabled(domainClass) ) {
					println("SmartClient is enabled for this domain class: ${event.source}")
					def dataSourceDir = new File("${basedir}/smartclient/ds")
					def widgetsDirPath = "${basedir}/smartclient/ui"
					String serverContextPath = ServletContextHolder.getServletContext().getContextPath()
					// FileWriter writer = new FileWriter( new File("${datasourceDir}/${domainClass.name}.ds.groovy") )
					GrailsSmartClientDataSourceUtil.generateDataSource( domainClass, dataSourceDir.getPath(), serverContextPath )
					// writer.close()
					/*
					File tmpFile = File.createTempFile("smartgwt-${domainClass.name}", null)
					FileWriter writer = new FileWriter( tmpFile )
					GrailsSmartClientDataSourceUtil.generateDataSource( domainClass, writer, serverContextPath )
					writer.close()
					tmpFile.renameTo( new File("${datasourceDir}/${domainClass.name}.ds.groovy") )
					*/
					GrailsSmartClientUtil.generateUIWidgetsForDomain( domainClass, widgetsDirPath )
				}

			}
			else {
				println("Changed resource is not recognised '${event.source.getClass().getName()}': ${event.source}")
			}
		}
    }	

    def onConfigChange = { event ->
		println("onConfigChange")
        // TODO Implement code that is executed when the project configuration changes.
        // The event is the same as for 'onChange'.
    }
}
