package com.emrul.grails.smartclient

import org.codehaus.groovy.grails.web.pages.GroovyPagesTemplateEngine
import groovy.text.Template
import org.codehaus.groovy.grails.commons.ApplicationHolder
import com.isomorphic.xml.XML

class SmartClientTagLib {

	static namespace = "smartclient"

	def loadDS = { attrs ->
		def exclude = attrs.'exclude'
		if ( attrs.ID ) {
			def config = com.isomorphic.base.Config.getGlobal();
			def dsPath = config.getString('project.datasources')
			def ctx = grailsAttributes.getApplicationContext() //ApplicationHolder.application.mainContext
			GroovyPagesTemplateEngine templateEngine = ctx.getBean("groovyPagesTemplateEngine")
			templateEngine.reloadEnabled = true;
			// def path = request.getSession().getServletContext().getRealPath("/")
			StringWriter fileContents = new StringWriter()
			fileContents.write("<isomorphicXML xmlns:xsi=\"nativeType\">")
			if ( attrs.ID == "*") {
				// def dsDir = new File( path, dsPath)
				def dsDir = new File(dsPath)
				dsDir.eachFileMatch(~".*ds.*xml") { dsFile ->
					def baseName = dsFile.name[0 .. dsFile.name.lastIndexOf('.ds.xml')-1]
					if ( !exclude?.contains(baseName) ) {
						Template template = templateEngine.createTemplate(dsFile)
						template.make().writeTo(fileContents)
					}
				}
			}
			else {
				if ( attrs.'ID' instanceof java.util.List ) {
					attrs.'ID'.each { name ->
						// def dsFile = new File( path, "${dsPath}/${attrs.ID}.ds.xml")
						def dsFile = new File( "${dsPath}/${name}.ds.xml")
						def baseName = dsFile.name[0 .. dsFile.name.lastIndexOf('.ds.xml')-1]
						if ( dsFile.exists() ) {
							if ( !exclude?.contains(baseName) ) {
								Template template = templateEngine.createTemplate(dsFile)
								template.make().writeTo(fileContents)
							}
						}
						else {
							// log some error, DS with supplied ID does not exist
						}
					}
				}
				else {
					// def dsFile = new File( path, "${dsPath}/${attrs.ID}.ds.xml")
					def dsFile = new File( "${dsPath}/${attrs.ID}.ds.xml")
					if ( dsFile.exists() ) {
						Template template = templateEngine.createTemplate(dsFile)
						template.make().writeTo(fileContents)
					}
					else {
						// Throw some error, DS with supplied ID does not exist
					}
				}
			}
			fileContents.write("</isomorphicXML>")

			XML.toJS(fileContents.toString(), out)
		}
	}


	def loadUI = { attrs ->
		if ( attrs.name ) {
			def config = com.isomorphic.base.Config.getGlobal();
			def uiPath = config.getString('project.ui')
			def ctx = grailsAttributes.getApplicationContext() //ApplicationHolder.application.mainContext
			GroovyPagesTemplateEngine templateEngine = ctx.getBean("groovyPagesTemplateEngine")
			templateEngine.reloadEnabled = true;
			//def path = request.getSession().getServletContext().getRealPath("/")
			StringWriter fileContents = new StringWriter()
			fileContents.write("<isomorphicXML xmlns:xsi=\"nativeType\">")
			if ( attrs.name == "*") {
				// def uiDir = new File( path, uiPath)
				def uiDir = new File( uiPath)
				uiDir.eachFileMatch(~".*ui.*xml") { uiFile ->
					Template template = templateEngine.createTemplate(uiFile)
					template.make().writeTo(fileContents)
				}
			}
			else {
				def uiFile = new File( "${uiPath}/${attrs.name}.ui.xml")
				if ( uiFile.exists() ) {
					Template template = templateEngine.createTemplate(uiFile)
					template.make().writeTo(fileContents)
				}
				else {
					// Throw some error, DS with supplied ID does not exist
				}
			}
			fileContents.write("</isomorphicXML>")

			XML.toJS(fileContents.toString(), out)
		}
	}
}
