/*
 */

import groovy.xml.MarkupBuilder
import org.codehaus.groovy.grails.commons.GrailsDomainClassProperty
import org.codehaus.groovy.grails.commons.GrailsDomainClass
import grails.persistence.Event
import com.isomorphic.js.IToJSON
import com.emrul.grails.smartclient.GrailsSmartClientDataSourceUtil
import com.emrul.grails.smartclient.GrailsSmartClientSharedUtil


Ant.property(environment:"env")
grailsHome = Ant.antProject.properties."env.GRAILS_HOME"

includeTargets << grailsScript("Init")
includeTargets << grailsScript("_GrailsArgParsing")
includeTargets << new File ( "${grailsHome}/scripts/Bootstrap.groovy" )

target(main: "The description of the script goes here!") {
	//depends( compile,loadApp)
	//depends(loadApp)
	depends( checkVersion, parseArguments, packageApp, loadApp)
    def argArray = argsMap["params"]
	println 'Generating data sources'

	// def GrailsSmartClientDataSourceUtil = grailsApp.classLoader.loadClass("com.emrul.grails.smartclient.GrailsSmartClientDataSourceUtil")
	// def GrailsSmartClientSharedUtil = grailsApp.classLoader.loadClass("com.emrul.grails.smartclient.GrailsSmartClientSharedUtil")

	def dataSourceDir = new File("${basedir}/smartclient/ds")

	if (!dataSourceDir.exists())
		dataSourceDir.mkdirs()

	grailsApp.domainClasses.findAll {GrailsSmartClientSharedUtil.isSmartClientEnabled(it) }.each { domainClass ->
        if ( argArray.size() == 0 || argArray.contains(domainClass.name)) {
            println "...${domainClass.name}"
            GrailsSmartClientDataSourceUtil.generateDataSource(domainClass, dataSourceDir.getPath(), serverContextPath)
        }
	}
}
setDefaultTarget(main)
