/*
 */

import groovy.xml.MarkupBuilder
import org.codehaus.groovy.grails.commons.GrailsDomainClassProperty
import org.codehaus.groovy.grails.commons.GrailsDomainClass
import grails.persistence.Event
import com.isomorphic.js.IToJSON
import com.emrul.grails.smartclient.GrailsSmartClientDataSourceUtil
import com.emrul.grails.smartclient.GrailsSmartClientSharedUtil
import com.emrul.grails.smartclient.GrailsSmartClientUtil


Ant.property(environment:"env")
grailsHome = Ant.antProject.properties."env.GRAILS_HOME"

includeTargets << grailsScript("Init")
includeTargets << grailsScript("_GrailsArgParsing")
includeTargets << new File ( "${grailsHome}/scripts/Bootstrap.groovy" )

target(main: "Script to generate SmartClient UI components") {
	//depends( compile,loadApp)
	//depends(loadApp)
	depends( checkVersion, parseArguments, packageApp, loadApp)
    def argArray = argsMap["params"]
	println 'Generating UI components'

	// def GrailsSmartClientDataSourceUtil = grailsApp.classLoader.loadClass("com.emrul.grails.smartclient.GrailsSmartClientDataSourceUtil")
	// def GrailsSmartClientSharedUtil = grailsApp.classLoader.loadClass("com.emrul.grails.smartclient.GrailsSmartClientSharedUtil")

    def widgetsDirPath = "${basedir}/smartclient/ui"
    def widgetsDir = new File(widgetsDirPath)
    if (!widgetsDir.exists())
        widgetsDir.mkdirs()

    if ( argArray.size() == 0 ) {
        // Generate all UI components
        println '... All components'
        GrailsSmartClientUtil.generateAllUIWidgets( grailsApp.domainClasses, widgetsDirPath )
    }
    else {
        grailsApp.domainClasses.findAll {GrailsSmartClientSharedUtil.isSmartClientEnabled(it) }.each { domainClass ->
            if ( argArray.size() == 0 || argArray.contains(domainClass.name)) {
                println "...${domainClass.name}"
                GrailsSmartClientUtil.generateUIWidgetsForDomain(domainClass, widgetsDir.getPath() )
            }
        }
    }
}
setDefaultTarget(main)
