package @artifact.package@;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.smartgwt.client.data.DSCallback;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.data.DSRequest;
import com.smartgwt.client.data.DSResponse;
import com.smartgwt.client.data.DataSource;
import com.smartgwt.client.core.KeyIdentifier;
import com.smartgwt.client.rpc.LoginRequiredCallback;
import com.smartgwt.client.rpc.RPCManager;
import com.smartgwt.client.rpc.RPCRequest;
import com.smartgwt.client.rpc.RPCResponse;
import com.smartgwt.client.types.Visibility;
import com.smartgwt.client.util.*;
import com.smartgwt.client.util.BooleanCallback;
import com.smartgwt.client.util.Page;
import com.smartgwt.client.util.SC;
import com.smartgwt.client.widgets.*;
import com.smartgwt.client.widgets.events.*;
import com.smartgwt.client.widgets.form.*;
import com.smartgwt.client.widgets.grid.*;
import com.smartgwt.client.widgets.grid.events.*;
import com.smartgwt.client.widgets.layout.*;
import com.smartgwt.client.widgets.viewer.DetailViewer;


/**
 * Generated SmartGWT Scaffolding.
 */
public class @artifact.name@ implements EntryPoint {


	protected DetailViewer getDetailViewerForDomain() {
		return getDetailViewerForDomain(getSelectedDomain());
	}

	protected DetailViewer getDetailViewerForDomain(String domainName) {
		return new DetailViewer(Canvas.getById("dv"+domainName).getJsObj());
	}

	protected DynamicForm getDynamicFormForDomain() {
		return getDynamicFormForDomain(getSelectedDomain());
	}

	protected DynamicForm getDynamicFormForDomain(String domainName) {
		return new DynamicForm(Canvas.getById("df"+domainName).getJsObj());
	}

	protected ListGrid getListGridForDomain() {
		return getListGridForDomain(getSelectedDomain());
	}

	protected ListGrid getListGridForDomain(String domainName) {
		return getListGrid("lg"+domainName);
	}

	protected VLayout getVLayout(String Id) {
		return new VLayout(Canvas.getById(Id).getJsObj());
	}

	protected HLayout getHLayout(String Id) {
		return new HLayout(Canvas.getById(Id).getJsObj());
	}

	protected ListGrid getListGrid(String Id) {
		return new ListGrid(Canvas.getById(Id).getJsObj());
	}

	protected IButton getIButton(String Id) {
		return new IButton(Canvas.getById(Id).getJsObj());
	}


	protected FilterBuilder getFilterBuilder(String Id) {
		return new FilterBuilder(Canvas.getById(Id).getJsObj());
	}

	protected String getSelectedDomain() {
		ListGrid lgDatasources = getListGrid("lgDatasources");
		ListGridRecord record = lgDatasources.getSelectedRecord();
		return record.getAttribute("domainName");
	}

	protected void setupDSListGridClickHandler() {
		ListGrid lgDatasources = getListGrid("lgDatasources");
		lgDatasources.addRecordClickHandler( new RecordClickHandler() {
			public void onRecordClick(RecordClickEvent event) {
				String domainName = event.getRecord().getAttribute("domainName");

				final FilterBuilder fbDomainFilter = new FilterBuilder();
				fbDomainFilter.setDataSource(DataSource.getDataSource(domainName));

				IButton filterButton = new IButton("Filter");
				filterButton.addClickHandler(new ClickHandler() {
					public void onClick(ClickEvent event) {
						getListGridForDomain().filterData(fbDomainFilter.getCriteria());
					}
				});

				ListGrid lgTargetDomain = getListGridForDomain(domainName);
				// Load data into list grid
				VLayout vlListGridContainer = getVLayout("vlListGridContainer");

				vlListGridContainer.setMembers(fbDomainFilter, filterButton, lgTargetDomain);
				// Hide the record canvas
				VLayout vlRecord = getVLayout("vlRecord");
				vlRecord.setVisibility(Visibility.HIDDEN);
			}
		});
	}

	protected void setupRecordActionButtons() {

		IButton btnNew = getIButton("btnNew");
		btnNew.addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				DynamicForm dfDomain = getDynamicFormForDomain();
				if ( dfDomain.isDirty() ) {
					SC.confirm("You have unsaved changes, you will lose these if you create a new record.",
					 new BooleanCallback() {
						public void execute( Boolean confirmed ) {
								if ( confirmed ) {
									getDynamicFormForDomain().editNewRecord();
								}
						}
					 });
				}
				else {
					dfDomain.editNewRecord();
				}
			}
		});

		IButton btnView = getIButton("btnView");
		btnView.addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				VLayout vlRecord = getVLayout("vlRecord");
				// Show only the detail viewer and the canvas containing record action buttons
				vlRecord.setMembers(getDetailViewerForDomain(), getHLayout("hlViewEditButtons"));
				// show only the edit button
				IButton btnEdit = getIButton("btnEdit");
				getHLayout("hlViewEditButtons").setVisibleMember(btnEdit);
			}
		});

		IButton btnEdit = getIButton("btnEdit");
		btnEdit.addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				// Show New, View, Save, Delete and Clear; hide Edit
				getIButton("btnNew").show();
				getIButton("btnView").show();
				getIButton("btnEdit").hide();
				getIButton("btnSave").show();
				getIButton("btnDelete").show();
				getIButton("btnClear").show();
				// Show only the dynamic form and the canvas containing record action buttons
				HLayout hlViewEditButtons = getHLayout("hlViewEditButtons");
				DynamicForm dfDomain = getDynamicFormForDomain();
				dfDomain.editSelectedData(getListGridForDomain());
				getVLayout("vlRecord").setMembers( dfDomain, hlViewEditButtons );
			}
		});

		IButton btnSave = getIButton("btnSave");
		btnSave.addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				DynamicForm dfDomain = getDynamicFormForDomain();
				dfDomain.saveData();
			}
		});


		getIButton("btnClear").addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				DynamicForm dfDomain = getDynamicFormForDomain();
				dfDomain.clearValues();
			}
		});

		IButton btnDelete = getIButton("btnDelete");
		btnDelete.addClickHandler( new ClickHandler() {
			public void onClick( ClickEvent event ) {
				DynamicForm dfDomain = getDynamicFormForDomain();
				
			}
		});
	}

	protected void setupDomainListGridClickHandler(String domainName) {
		ListGrid lgDomain = getListGridForDomain(domainName);
		DetailViewer dvDomain = getDetailViewerForDomain(domainName);
		dvDomain.setPadding(5);
		RecordClickHandler rch = new RecordClickHandler() {
				public void onRecordClick(RecordClickEvent event) {
					VLayout vlRecord = getVLayout("vlRecord");
					HLayout hlViewEditButtons = getHLayout("hlViewEditButtons");
					// Load data into detail viewer
					DetailViewer dvDomain = getDetailViewerForDomain();
					dvDomain.viewSelectedData(getListGridForDomain());
					// Show only the detail viewer and the canvas containing record action buttons
					vlRecord.setMembers(dvDomain, hlViewEditButtons);
					// show only the edit button
					IButton btnEdit = getIButton("btnEdit");
					hlViewEditButtons.setVisibleMember(btnEdit);
					// Show record canvas
					vlRecord.setVisibility(Visibility.VISIBLE);
				}
		};

		lgDomain.addRecordClickHandler(rch);

	}

    /**
     * This is the entry point method.
     */
    public void onModuleLoad() {
		if (!GWT.isScript()) {
			KeyIdentifier debugKey = new KeyIdentifier();
			debugKey.setCtrlKey(true);
			debugKey.setKeyName("D");
			Page.registerKey(debugKey, new KeyCallback() {
				public void execute(String keyName) {
					SC.showConsole();
				}
			});
		}

		setupDSListGridClickHandler();
		setupRecordActionButtons();


		DataSource appDomainInfo = DataSource.getDataSource("_AppDomainInfo");
		appDomainInfo.fetchData(null, new DSCallback() {
			public void execute(DSResponse dsResponse, Object o, DSRequest dsRequest) {
				Record[] records = dsResponse.getData();
				for ( int x = 0; x < records.length; x++ ) {
					String domainName = records[x].getAttribute("domainName");
					setupDomainListGridClickHandler(domainName);
				}
			}
		});


		VLayout vlMain = getVLayout("vlMain");
		vlMain.draw();
    }
}
